<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/30/2005 *
 * ================                             Last change: 04/30/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_country.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Manage country codes                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Country codes verwalten                          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Add new code?
if ((isPostRequestElementSet('add')) && (isPostRequestElementSet(('code'))) && (isPostRequestElementSet(('descr')))) {
	// Check if country code does already exist
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_countries` WHERE code='%s' LIMIT 1",
	array(strtoupper(postRequestElement('code'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Save entry
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_countries` (code, descr, is_active) VALUES ('%s','%s','%s')",
		array(
		strtoupper(substr(postRequestElement('code'), 0, 2)),
		postRequestElement('descr'),
		postRequestElement('is_active')
		), __FILE__, __LINE__);

		// Country added
		$message = sprintf(getMessage('ADMIN_COUNTRY_ADDED'), strtoupper(postRequestElement('descr')));
	} else {
		// Free memory
		SQL_FREERESULT($result);

		// Does already exist
		$message = sprintf(getMessage('ADMIN_COUNTRY_ALREADY'), strtoupper(postRequestElement('code')));
	}

	// Display message
	loadTemplate('admin_settings_saved', false, $message);
} elseif ((isPostRequestElementSet('change')) && (isPostRequestElementSet('id'))) {
	// Change all status
	adminChangeActivationStatus(postRequestElement('id'), 'countries', 'is_active');

	// Show next link
	loadTemplate('admin_next_link', false, array(
		'url'   => 'modules.php?module=admin&amp;what=list_country',
		'title' => getMessage('ADMIN_COUNTRY_ACTIVATION_NEXT_LINK')
	));
} elseif (((isPostRequestElementSet('edit')) || (isPostRequestElementSet('delete'))) && (isPostRequestElementSet('id'))) {
	if (count(postRequestElement('id')) > 0) {
		if (isPostRequestElementSet('edit')) {
			// Edit template
			$row    = 'admin_list_country_edit_row';
			$post   = 'modify';
			$class  = 'admin_submit';
			$submit = getMessage('ADMIN_COUNTRY_EDIT_NOW');
			$title  = getMessage('ADMIN_COUNTRY_EDIT_TITLE');
			$reset  = '<input type="reset" class="admin_reset" value="{--UNDO_SELECTIONS--}" />&nbsp;*';
		} else {
			// Delete template
			$row    = 'admin_list_country_del_row';
			$post   = 'remove';
			$class  = 'admin_delete';
			$submit = getMessage('ADMIN_COUNTRY_DELETE_NOW');
			$title  = getMessage('ADMIN_COUNTRY_DELETE_TITLE');
			$reset  = '';
		}

		// Edit all selected country codes
		$OUT = ''; $SW = 2;
		foreach (postRequestElement('id') as $id => $status) {
			// Load data from DB
			$result = SQL_QUERY_ESC("SELECT code, descr FROM `{?_MYSQL_PREFIX?}_countries` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Load data
				list($code, $descr) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				// Prepare data, load row template and switch colors
				$content = array(
					'id'    => $id,
					'code'  => $code,
					'descr' => $descr,
					'sw'    => $SW,
				);

				if ($post == 'modify') {
					// Generate default selection in edit-mode
					$content['status'] = generateOptionList('/ARRAY/', array('Y', 'N'), array(getMessage('YES'), getMessage('NO')), $status);
				} else {
					// Only display status when in delete-mode
					$content['status'] = translateYesNo($status);
				}

				// Insert row template and switch color
				$OUT .= loadTemplate($row, true, $content);
				$SW = 3 - $SW;
			}
		}

		// Prepare content for template
		$content = array(
			'rows'   => $OUT,
			'mode'   => $post,
			'class'  => $class,
			'title'  => $title,
			'submit' => $submit,
			'reset'  => $reset,
		);

		// Load main template
		loadTemplate('admin_list_country_form', false, $content);
	}
} else {
	// Shall we modify / remove entries now?
	$message = ''; initSqls();
	if ((isPostRequestElementSet(('modify'))) && (isPostRequestElementSet('id'))) {
		// Modify
		foreach (postRequestElement('id') as $id => $sel) {
			addSql("UPDATE `{?_MYSQL_PREFIX?}_countries` SET `code`='".postRequestElement('code', $id)."', `descr`='".postRequestElement('descr', $id)."', `is_active`='".postRequestElement('is_active', $id)."' WHERE `id`='".$id."' LIMIT 1");
		}

		// Create message
		$message = getMessage('ADMIN_COUNTRIES_MODIFIED');
	} elseif ((isPostRequestElementSet('remove')) && (isPostRequestElementSet('id'))) {
		// Remove
		$IDs = implode(',', array_keys(postRequestElement('id')));
		addSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_countries` WHERE `id` IN (".$IDs.") LIMIT ".count(postRequestElement('id'))."");

		// Create message
		$message = getMessage('ADMIN_COUNTRIES_REMOVED');
	}

	if ((!empty($message)) && (countSqls() > 0)) {
		// Run SQL commands
		runFilterChain('run_sqls');

		// Display message
		loadTemplate('admin_settings_saved', false, $message);
	}

	// Load currenty setup country codes to list
	$result = SQL_QUERY('SELECT id, code, descr, is_active FROM `{?_MYSQL_PREFIX?}_countries` ORDER BY code',
	__FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// List all countries
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result)) {
			// Prepare array for the template
			$content['active'] = translateYesNo($content['is_active']);
			$content['sw']     = $SW;

			// Load row template and switch colors
			$OUT .= loadTemplate('admin_list_country_row', true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// No code setup so far (not possible by this software! 'DE' for 'Deutschland' is default
		$OUT = loadTemplate('admin_list_country_no_row', true);
	}

	// Add list to constant for the template
	$content['rows'] = $OUT;

	// Include add template
	$content['add_form'] = loadTemplate('admin_add_country', true);

	// Load main template
	loadTemplate('admin_list_country', false, $content);
}

// [EOF]
?>
